libdap::Str Class Reference

Holds character string data. More...

`#include <Str.h>`

Inheritance diagram for libdap::Str:

## Public Types

typedef stack< BaseType * > | btp_stack

## Public Member Functions

virtual void | add_var (BaseType *bt, Part part=nil)
| Add a variable.
virtual void | add_var_nocopy (BaseType *bt, Part part=nil)
unsigned int | buf2val (void **val) override
virtual bool | check_semantics (string &msg, bool all=false)
| Compare an object's current state with the semantics of its type.
virtual void | clear_local_data ()
void | compute_checksum (Crc32 &checksum) override
| include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.
bool | d4_ops (BaseType *b, int op) override
virtual string | dataset () const
| Returns the name of the dataset used to create this instance.
void | deserialize (D4StreamUnMarshaller &um, DMR &dmr) override
bool | deserialize (UnMarshaller &um, DDS *dds, bool reuse=false) override
| Receive data from the net.
void | dump (ostream &strm) const override
| dumps information about this object
virtual int | element_count (bool leaves=false)
| Count the members of constructor types.
virtual string | esc_string_variable_value (const string &s)
| Escape non-printable characters and quotes from a Str variable value. The value printed is used mostly for debugging and for other diagnostics. Strings an non-printable characters are escaped using a backslash.
virtual std::string | FQN () const
virtual BaseType * | get_ancestor ()
virtual AttrTable & | get_attr_table ()
virtual BaseType * | get_parent () const
virtual bool | is_constructor_type () const
| Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.
virtual bool | is_dap4 () const
virtual bool | is_in_selection ()
| Is this variable part of the current selection?
virtual bool | is_simple_type () const
| Returns true if the instance is a numeric, string or URL type variable.
virtual bool | is_vector_type () const
| Returns true if the instance is a vector (i.e., array) type variable.
int | length () const override
| How many elements are in this variable? Uses -1 in places.
int64_t | length_ll () const override
| Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.
virtual string | name () const
| Returns the name of the class instance.
Str & | operator= (const Str &rhs)
bool | ops (BaseType *b, int op) override
| Evaluate relational operators.
virtual void | print_dap4 (XMLWriter &xml, bool constrained=false)
virtual void | print_decl (FILE *out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure.
virtual void | print_decl (ostream &out, string space=" ", bool print_semi=true, bool constraint_info=false, bool constrained=false)
| Print an ASCII representation of the variable structure.
void | print_val (FILE *out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
void | print_val (ostream &out, string space="", bool print_decl_p=true) override
| Prints the value of the variable.
virtual void | print_xml (FILE *out, string space=" ", bool constrained=false)
virtual void | print_xml (ostream &out, string space=" ", bool constrained=false)
virtual void | print_xml_writer (XMLWriter &xml, bool constrained=false)
BaseType * | ptr_duplicate () override
virtual bool | read ()
| Read data into a local buffer.
virtual bool | read_p ()
| Has this variable been read?
virtual bool | send_p ()
| Should this variable be sent?
bool | serialize (ConstraintEvaluator &eval, DDS &dds, Marshaller &m, bool ce_eval=true) override
| Move data to the net, then remove them from the object.
void | serialize (D4StreamMarshaller &m, DMR &dmr, bool filter=false) override
| Serialize an Int8.
virtual void | set_attr_table (const AttrTable &at)
virtual void | set_in_selection (bool state)
virtual void | set_is_dap4 (const bool v)
virtual void | set_length (int64_t)
| Set the number of elements for this variable. use -1 to indicate nothing set.
virtual void | set_length_ll (int64_t)
| Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.
virtual void | set_name (const string &n)
| Sets the name of the class instance.
virtual void | set_parent (BaseType *parent)
virtual void | set_read_p (bool state)
| Sets the value of the read_p property.
virtual void | set_send_p (bool state)
virtual void | set_synthesized_p (bool state)
virtual void | set_type (const Type &t)
| Sets the type of the class instance.
virtual bool | set_value (const string &value)
| Str (const Str &copy_from)
| Str (const string &n)
| Str (const string &n, const string &d)
virtual bool | synthesized_p ()
virtual string | toString ()
virtual void | transfer_attributes (AttrTable *at)
virtual std::vector< BaseType * > * | transform_to_dap2 (AttrTable *parent_attr_table)
| DAP4 to DAP2 transform.
virtual void | transform_to_dap4 (D4Group *root, Constructor *container)
| DAP2 to DAP4 transform.
virtual Type | type () const
| Returns the type of the class instance.
virtual string | type_name () const
| Returns the type of the class instance as a string.
unsigned int | val2buf (void *val, bool reuse=false) override
virtual string | value () const
virtual BaseType * | var (const string &name, btp_stack &s)
virtual BaseType * | var (const string &name="", bool exact_match=true, btp_stack *s=nullptr)
| Returns a pointer to a member of a constructor class.
unsigned int | width (bool=false) const override

How many bytes does this variable use Return the number of bytes of storage this variable uses. For scalar types, this is pretty simple (an int32 uses 4 bytes, etc.). For arrays and Constructors, it is a bit more complex. Note that a scalar String variable uses sizeof(String*) bytes, not the length of the string value. The width() of a String array returns the number of elements in the array times sizeof(String*).

int64_t | width_ll (bool=false) const override
virtual D4Attributes * | attributes ()
virtual void | set_attributes (D4Attributes *)
virtual void | set_attributes_nocopy (D4Attributes *)
Abstract Methods
virtual void | intern_data (ConstraintEvaluator &eval, DDS &dds)
virtual void | intern_data ()
| Read data into this variable.
virtual bool | is_dap4_projected (std::vector< string > &projected_dap4_inventory)

## Protected Member Functions

void | m_duplicate (const BaseType &bt)
| Perform a deep copy.

## Protected Attributes

string | d_buf

## Detailed Description

Holds character string data.

See also
  BaseType
  Url

Definition at line 62 of file Str.h.

## Member Typedef Documentation

## btp_stack

typedef stack<BaseType *> libdap::BaseType::btp_stack

inherited

Definition at line 151 of file BaseType.h.

## Constructor & Destructor Documentation

## Str() [1/3]

libdap::Str::Str | ( | const string & | n | ) |

The Str constructor requires only the name of the variable to be created. The name may be omitted, which will create a nameless variable. This may be adequate for some applications.

Parameters

  n | A string containing the name of the variable to be created.

Definition at line 92 of file Str.cc.

## Str() [2/3]

libdap::Str::Str | ( | const string & | n,
|  | const string & | d
| ) |  |

The Str server-side constructor accepts the name of the variable and the dataset name from which this instance is created.

Parameters

  n | A string containing the name of the variable to be created.
  d | A string containing the name of the dataset from which this variable is created

Definition at line 102 of file Str.cc.

## ~Str()

virtual libdap::Str::~Str | ( |  | ) |

inline virtual

Definition at line 70 of file Str.h.

## Str() [3/3]

libdap::Str::Str | ( | const Str & | copy_from | ) |

Definition at line 105 of file Str.cc.

## Member Function Documentation

## add_var()

void libdap::BaseType::add_var | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

virtual inherited

Add a variable.

Adds a variable to an instance of a constructor class, such as Array, Structure et cetera. This function is only used by those classes. For constructors with more than one variable, the variables appear in the same order in which they were added (i.e., the order in which add_var() was called). Since this method is only for use by Vectors and Constructors, the BaseType implementation throws InternalErr.

Note
  For the implementation of this method in Structure, Sequence, et c., first copy bt and then insert the copy. If bt is itself a constructor type you must either use the var() method to get a pointer to the actual instance added to `*this` or you must first add all of bt's children to it before adding it to `*this`. The implementations should use m_duplicate() to perform a deep copy of bt.

Todo:
  We should get rid of the Part parameter and adopt the convention that the first variable is the Array and all subsequent ones are Maps (when dealing with a Grid, the only time Part matters). This would enable several methods to migrate from Structure, Sequence and Grid to Constructor.

Parameters

  bt | The variable to be added to this instance. The caller of this method must free memory it allocates for `v`. This method will make a deep copy of the object pointed to by `v`.
  part | The part of the constructor data to be modified. Only meaningful for Grid variables.

See also
  Part

Reimplemented in libdap::Grid, libdap::Constructor, libdap::Array, and libdap::Vector.

Definition at line 821 of file BaseType.cc.

## add_var_nocopy()

void libdap::BaseType::add_var_nocopy | ( | BaseType * | bt,
|  | Part | part = `nil`
| ) |  |

virtual inherited

Reimplemented in libdap::Grid, and libdap::Constructor.

Definition at line 827 of file BaseType.cc.

## attributes()

D4Attributes * libdap::BaseType::attributes | ( |  | ) |

virtual inherited

DAP4 Attribute methods

Definition at line 596 of file BaseType.cc.

## buf2val()

unsigned int libdap::Str::buf2val | ( | void ** | val | ) |

override virtual

Read the object's value and put a copy in the C++ string object referenced by **val. If *val is null, this method will allocate a string object using new and store the result there. If *val is not null, it will assume that *val references a string object and put the value there.

Parameters

  val | A pointer to null or to a string object.

Returns
  The sizeof(string*)

Exceptions

  InternalErr | Thrown if val is null.

Implements libdap::BaseType.

Definition at line 210 of file Str.cc.

## check_semantics()

bool libdap::BaseType::check_semantics | ( | string & | msg,
|  | bool | all = `false`
| ) |  |

virtual inherited

Compare an object's current state with the semantics of its type.

This function checks the class instance for internal consistency. This is important to check for complex constructor classes. For BaseType, an object is semantically correct if it has both a non-null name and type.

For example, an Int32 instance would return FALSE if it had no name or no type defined. A Grid instance might return FALSE for more complex reasons, such as having Map arrays of the wrong size or shape.

This function is used by the DDS class, and will rarely, if ever, be explicitly called by a DODS application program. A variable must pass this test before it is sent, but there may be many other stages in a retrieve operation where it would fail.

Returns
  Returns FALSE when the current state violates some aspect of the type semantics, TRUE otherwise.

Parameters

  msg | A returned string, containing a message indicating the source of any problem.
  all | For complex constructor types (Grid, Sequence, Structure), this flag indicates whether to check the semantics of the member variables, too.

See also
  DDS::check_semantics

Reimplemented in libdap::Grid, libdap::Array, libdap::Constructor, and libdap::Vector.

Definition at line 1215 of file BaseType.cc.

## clear_local_data()

virtual void libdap::BaseType::clear_local_data | ( |  | ) |

inline virtual inherited

Remove any read or set data in the private data of the variable, setting read_p() to false. Used to clear any dynamically allocated storage that holds (potentially large) data. For the simple types, this no-op version is all that's needed. Vector and some other classes define a special version and have serialize() implementations that call it to free data as soon as possible after sending it.

Note
  Added 7/5/15 jhrg
  Any specialization of this should make sure to reset the read_p property.

Reimplemented in libdap::D4Opaque, libdap::Sequence, libdap::D4Sequence, and libdap::Vector.

Definition at line 181 of file BaseType.h.

## compute_checksum()

void libdap::Str::compute_checksum | ( | Crc32 & | checksum | ) |

override virtual

include the data for this variable in the checksum DAP4 includes a checksum with every data response. This method adds the variable's data to that checksum.

Parameters

  checksum | A Crc32 instance that holds the current checksum.

Implements libdap::BaseType.

Definition at line 172 of file Str.cc.

## d4_ops()

bool libdap::Str::d4_ops | ( | BaseType * | b,
|  | int | op
| ) |  |

override virtual

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented from libdap::BaseType.

Definition at line 335 of file Str.cc.

## dataset()

string libdap::BaseType::dataset | ( |  | ) | const

virtual inherited

Returns the name of the dataset used to create this instance.

A dataset from which the data is to be read. The meaning of this string will vary among different types of data sources. It may be the name of a data file or an identifier used to read data from a relational database.

Definition at line 355 of file BaseType.cc.

## deserialize() [1/2]

void libdap::Str::deserialize | ( | D4StreamUnMarshaller & | um,
|  | DMR & | dmr
| ) |  |

override virtual

The DAP4 deserialization method.

Parameters

  um |
  dmr |

Exceptions

  Error | or InternalErr

Reimplemented from libdap::BaseType.

Definition at line 195 of file Str.cc.

## deserialize() [2/2]

bool libdap::Str::deserialize | ( | UnMarshaller & | um,
|  | DDS * | dds,
|  | bool | reuse = `false`
| ) |  |

override virtual

Receive data from the net.

Receives data from the network connection identified by the `source` parameter. The data is put into the class data buffer according to the input `dds`.

This function is only used on the client side of the DODS client/server connection.

Parameters

  um | An UnMarshaller that knows how to deserialize data types
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure. This would have been received from the server in an earlier transmission.
  reuse | A boolean value, indicating whether the class internal data storage can be reused or not. If this argument is TRUE, the class buffer is assumed to be large enough to hold the incoming data, and it is not reallocated. If FALSE, new storage is allocated. If the internal buffer has not been allocated at all, this argument has no effect.

Returns
  Always returns TRUE.

Exceptions

  Error | when a problem reading from the UnMarshaller is found.

See also
  DDS

Reimplemented from libdap::BaseType.

Definition at line 164 of file Str.cc.

## dump()

void libdap::Str::dump | ( | ostream & | strm | ) | const

override virtual

dumps information about this object

Displays the pointer value of this instance and information about this instance.

Parameters

  strm | C++ i/o stream to dump the information to

Returns
  void

Reimplemented from libdap::BaseType.

Definition at line 367 of file Str.cc.

## element_count()

int libdap::BaseType::element_count | ( | bool | leaves = `false` | ) |

virtual inherited

Count the members of constructor types.

Return a count of the total number of variables in this variable. This is used to count the number of variables held by a constructor variable - for simple type and vector variables it always returns 1.

For compound data types, there are two ways to count members. You can count the members, or you can count the simple members and add that to the count of the compound members. For example, if a Structure contains an Int32 and another Structure that itself contains two Int32 members, the element count of the top-level structure could be two (one Int32 and one Structure) or three (one Int32 by itself and two Int32's in the subsidiary Structure). Use the leaves parameter to control which kind of counting you desire.

Returns
  Returns 1 for simple types. For compound members, the count depends on the leaves argument.

Parameters

  leaves | This parameter is only relevant if the object contains other compound data types. If FALSE, the function counts only the data variables mentioned in the object's declaration. If TRUE, it counts the simple members, and adds that to the sum of the counts for the compound members. This parameter has no effect for simple type variables.

Reimplemented in libdap::Vector, and libdap::Constructor.

Definition at line 440 of file BaseType.cc.

## esc_string_variable_value()

string libdap::Str::esc_string_variable_value | ( | const string & | s | ) |

virtual

Escape non-printable characters and quotes from a Str variable value. The value printed is used mostly for debugging and for other diagnostics. Strings an non-printable characters are escaped using a backslash.

Parameters

  s | The value to modify.

Returns
  The modified value.

Definition at line 289 of file Str.cc.

## FQN()

string libdap::BaseType::FQN | ( |  | ) | const

virtual inherited

Return the FQN for this variable. This will include the D4 Group component of the name.

Returns
  The FQN in a string

Reimplemented in libdap::Constructor, and libdap::D4Group.

Definition at line 329 of file BaseType.cc.

## get_ancestor()

BaseType * libdap::BaseType::get_ancestor | ( |  | ) |

virtual inherited

Definition at line 754 of file BaseType.cc.

## get_attr_table()

AttrTable & libdap::BaseType::get_attr_table | ( |  | ) |

virtual inherited

Get this variable's AttrTable. It's generally a bad idea to return a reference to a contained object, but in this case it seems that building an interface inside BaseType is overkill.

Use the AttrTable methods to manipulate the table.

Definition at line 579 of file BaseType.cc.

## get_parent()

BaseType * libdap::BaseType::get_parent | ( |  | ) | const

virtual inherited

Return a pointer to the Constructor or Vector which holds (contains) this variable. If this variable is at the top level, this method returns null.

Returns
  A BaseType pointer to the variable's parent.

Definition at line 748 of file BaseType.cc.

## intern_data() [1/2]

void libdap::BaseType::intern_data | ( |  | ) |

virtual inherited

Read data into this variable.

Parameters

  eval | Evaluator for a constraint expression
  dmr | DMR for the whole dataset

Reimplemented in libdap::Constructor, libdap::D4Group, libdap::D4Sequence, and libdap::Vector.

Definition at line 936 of file BaseType.cc.

## intern_data() [2/2]

void libdap::BaseType::intern_data | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds
| ) |  |

virtual inherited

Similar to using serialize() and deserialize() together in one object. Data are read as for serialize and those values are stored in the objects as deserialize() does but does not write and then read data to/from a stream.

This method is defined by the various data type classes. It calls the read() abstract method. Unlike serialize(), this method does not clear the memory use to hold the data values, so the caller should make sure to delete the DDS or the variable as soon as possible.

Note
  This version of the method is specific to DAP2. It will throw an exception if called on a variable where the is_dap4 property is true.

Parameters

  eval | Use this as the constraint expression evaluator.
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.

Reimplemented in libdap::D4Sequence, libdap::Sequence, libdap::Constructor, and libdap::Vector.

Definition at line 914 of file BaseType.cc.

## is_constructor_type()

bool libdap::BaseType::is_constructor_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a constructor (i.e., Structure, Sequence or Grid) type variable.

Returns
  True if the instance is a Structure, Sequence or Grid, False otherwise.

Definition at line 409 of file BaseType.cc.

## is_dap4()

virtual bool libdap::BaseType::is_dap4 | ( |  | ) | const

inline virtual inherited

Definition at line 183 of file BaseType.h.

## is_dap4_projected()

bool libdap::BaseType::is_dap4_projected | ( | std::vector< string > & | inventory | ) |

virtual inherited

When send_p() is true and the attributes contain dap4 data types then a description of the instance is added to the inventory and true is returned.

Parameters

  inventory | is a value-result parameter

Returns
  True when send_p() is true and the attributes contain dap4 data types, false otherwise

Reimplemented in libdap::Constructor, libdap::D4Group, libdap::Int8, libdap::Array, libdap::Vector, libdap::Int64, and libdap::UInt64.

Definition at line 1323 of file BaseType.cc.

## is_in_selection()

bool libdap::BaseType::is_in_selection | ( |  | ) |

virtual inherited

Is this variable part of the current selection?

Does this variable appear in either the selection part or as a function argument in the current constrain expression. If this property is set (true) then implementations of the read() method should read this variable.

Note
  This method does not check, nor does it know about the semantics of, string arguments passed to functions. Those functions might include variable names in strings; they are responsible for reading those variables. See the grid (func_grid_select()) for an example.

See also
  BaseType::read()

Definition at line 700 of file BaseType.cc.

## is_simple_type()

bool libdap::BaseType::is_simple_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a numeric, string or URL type variable.

Returns
  True if the instance is a scalar numeric, String or URL variable, False otherwise. Arrays (even of simple types) return False.

See also
  is_vector_type()

Definition at line 390 of file BaseType.cc.

## is_vector_type()

bool libdap::BaseType::is_vector_type | ( |  | ) | const

virtual inherited

Returns true if the instance is a vector (i.e., array) type variable.

Returns
  True if the instance is an Array, False otherwise.

Definition at line 399 of file BaseType.cc.

## length()

int libdap::Str::length | ( |  | ) | const

override virtual

How many elements are in this variable? Uses -1 in places.

Returns
  The number of elements; 1 for scalars

Deprecated:
  Use length_ll() instead

Reimplemented from libdap::BaseType.

Definition at line 127 of file Str.cc.

## length_ll()

int64_t libdap::Str::length_ll | ( |  | ) | const

override virtual

Get the number of elements in this variable This version of the function deprecates length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that a Vector/Array holds no values yet (as opposed to zero values). For types not derived from Vector, there is always one element.

Returns
  The number of elements in this variable

Reimplemented from libdap::BaseType.

Definition at line 133 of file Str.cc.

## m_duplicate()

void libdap::BaseType::m_duplicate | ( | const BaseType & | bt | ) |

protected inherited

Perform a deep copy.

Perform a deep copy. Copies the values of bt into `*this`. Pointers are dereferenced and their values are copied into a newly allocated instance.

Parameters

  bt | The source object.

Definition at line 86 of file BaseType.cc.

## name()

string libdap::BaseType::name | ( |  | ) | const

virtual inherited

Returns the name of the class instance.

Definition at line 317 of file BaseType.cc.

## operator=()

Str & libdap::Str::operator= | ( | const Str & | rhs | ) |

Definition at line 117 of file Str.cc.

## ops()

bool libdap::Str::ops | ( | BaseType * | b,
|  | int | op
| ) |  |

override virtual

Evaluate relational operators.

This method contains the relational operators used by the constraint expression evaluator in the DDS class. Each class that wants to be able to evaluate relational expressions must overload this function. The implementation in BaseType throws an InternalErr exception. The DAP library classes Byte, ..., Url provide specializations of this method. It is not meaningful for classes such as Array because relational expressions using Array are not supported.

The op argument refers to a table generated by bison from the constraint expression parser. Use statements like the following to correctly interpret its value:

    switch (op) {
        case EQUAL: return i1 == i2;
        case NOT_EQUAL: return i1 != i2;
        case GREATER: return i1 > i2;
        case GREATER_EQL: return i1 >= i2;
        case LESS: return i1 < i2;
        case LESS_EQL: return i1 <= i2;
        case REGEXP: throw Error("Regular expressions are not supported for integer values");
        default: throw Error("Unknown operator");
    }

This function is used by the constraint expression evaluator.

Parameters

  b | Compare the value of this instance with b.
  op | An integer index indicating which relational operator is implied. Choose one from the following: `EQUAL`, `NOT_EQUAL`, `GREATER`, `GREATER_EQL`, `LESS`, `LESS_EQL`, and `REGEXP`.

Returns
  The boolean value of the comparison.

See also
  BaseType::d4_ops(BaseType *, int)

Reimplemented from libdap::BaseType.

Definition at line 307 of file Str.cc.

## print_dap4()

void libdap::BaseType::print_dap4 | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the DAP4 XML representation for this variable. This method is used to build the DAP4 DMR response object.

Parameters

  xml | An XMLWriter that will do the serialization
  constrained | True if the response should show the variables subject to the current constraint expression.

Reimplemented in libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1170 of file BaseType.cc.

## print_decl() [1/2]

void libdap::BaseType::print_decl | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented in libdap::Grid, libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1009 of file BaseType.cc.

## print_decl() [2/2]

void libdap::BaseType::print_decl | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | print_semi = `true`,
|  | bool | constraint_info = `false`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Print an ASCII representation of the variable structure.

Write the variable's declaration in a C-style syntax. This function is used to create textual representation of the Data Descriptor Structure (DDS). See The DODS User Manual for information about this structure.

A simple array declaration might look like this:

    Float64 lat[lat = 180];

While a more complex declaration (for a Grid, in this case), would look like this:

    Grid {
    ARRAY:
    Int32 sst[time = 404][lat = 180][lon = 360];
    MAPS:
    Float64 time[time = 404];
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    } sst;

Parameters

  out | The output stream on which to print the declaration.
  space | Each line of the declaration will begin with the characters in this string. Usually used for leading spaces.
  print_semi | A boolean value indicating whether to print a semicolon at the end of the declaration.
  constraint_info | A boolean value indicating whether constraint information is to be printed with the declaration. If the value of this parameter is TRUE, `print_decl()` prints the value of the variable's `send_p()` flag after the declaration.
  constrained | If this boolean value is TRUE, the variable's declaration is only printed if is the `send_p()` flag is TRUE. If a constraint expression is in place, and this variable is not requested, the `send_p()` flag is FALSE.

See also
  DDS
  DDS::CE

Reimplemented in libdap::Grid, libdap::Array, libdap::Constructor, and libdap::D4Group.

Definition at line 1060 of file BaseType.cc.

## print_val() [1/2]

void libdap::Str::print_val | ( | FILE * | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output stream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Reimplemented from libdap::BaseType.

Definition at line 274 of file Str.cc.

## print_val() [2/2]

void libdap::Str::print_val | ( | ostream & | out,
|  | string | space = `""`,
|  | bool | print_decl_p = `true`
| ) |  |

override virtual

Prints the value of the variable.

Prints the value of the variable, with its declaration. This function is primarily intended for debugging DODS applications. However, it can be overloaded and used to do some useful things. Take a look at the asciival and writeval clients, both of which overload this to output the values of variables in different ways.

Parameters

  out | The output ostream on which to print the value.
  space | This value is passed to the print_decl() function, and controls the leading spaces of the output.
  print_decl_p | A boolean value controlling whether the variable declaration is printed as well as the value.

Implements libdap::BaseType.

Definition at line 295 of file Str.cc.

## print_xml() [1/2]

void libdap::BaseType::print_xml | ( | FILE * | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination.
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Deprecated:

Reimplemented in libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1111 of file BaseType.cc.

## print_xml() [2/2]

void libdap::BaseType::print_xml | ( | ostream & | out,
|  | string | space = `" "`,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Deprecated:

Reimplemented in libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1126 of file BaseType.cc.

## print_xml_writer()

void libdap::BaseType::print_xml_writer | ( | XMLWriter & | xml,
|  | bool | constrained = `false`
| ) |  |

virtual inherited

Write the XML representation of this variable. This method is used to build the DDX XML response.

Parameters

  out | Destination output stream
  space | Use this to indent child declarations. Default is "".
  constrained | If true, only print this if it's part part of the current projection. Default is False.

Reimplemented in libdap::D4Enum, libdap::Grid, libdap::Array, and libdap::Constructor.

Definition at line 1140 of file BaseType.cc.

## ptr_duplicate()

BaseType * libdap::Str::ptr_duplicate | ( |  | ) |

override virtual

Clone this instance. Allocate a new instance and copy `*this` into it. This method must perform a deep copy.

    @note This method should \e not copy data values, but must copy all
    other fields in the object.

Returns
  A newly allocated copy of `this`.

Implements libdap::BaseType.

Reimplemented in libdap::Url.

Definition at line 111 of file Str.cc.

## read()

bool libdap::BaseType::read | ( |  | ) |

virtual inherited

Read data into a local buffer.

This method should be implemented for each of the data type classes (Byte, ..., Grid) when using the DAP class library to build a server. This method is only for DAP servers. The library provides a default definition here which throws an InternalErr exception unless the read_p property has been set. In that case it returns false, indicating that all the data have been read. The latter case can happen when building a constant value that needs to be passed to a function. The variable/constant is loaded with a value when it is created.

When implementing a new DAP server, the Byte, ..., Grid data type classes are usually specialized. In each of those specializations read() should be defined to read values from the data source and store them in the object's local buffer. The read() method is called by other methods in this library. When writing read(), follow these rules:

- read() should throw Error if it encounters an error. The message should be verbose enough to be understood by someone running a client on a different machine.
- The value(s) should be read if and only if either send_p() or is_in_selection() return true. If neither of these return true, the value(s) should not be read. This is important when writing read() for a Constructor type such as Grid where a client may ask for only the map vectors (and thus reading the much larger Array part is not needed).
- For each specialization of read(), the method should first test the value of the `read_p` property (using the read_p() method) and read values only if the value of read_p() is false. Once the read() method reads data and stores it in the instance, it must set the value of the `read_p` property to true using set_read_p(). If your read() methods fail to do this data may not serialize correctly.
- The Array::read() and Grid::read() methods should take into account any restrictions on Array sizes.
- If you are writing Sequence::read(), be sure to check the documentation for Sequence::read_row() and Sequence::serialize() so you understand how Sequence::read() is being called.

- For Sequence::read(), your specialization must correctly manage the `unsent_data` property and row count in addition to the `read_p` property (handle the `read_p` property as describe above). For a Sequence to serialize correctly, once all data from the Sequence has been read, `unsent_data` property must be set to false (use Sequence::set_unsent_data()). Also, at that time the row number counter must be reset (use Sequence::reset_row_counter()). Typically the correct time to set `unsent_data` to false and reset the row counter is the time when Sequence::read() return false indicating that all the data for the Sequence have been read. Failure to handle these tasks will break serialization of nested Sequences. Note that when Sequence::read() returns with a result of true (indicating there is more data to send, the value of the `unsent_data` property should be true.

  Also, if you server must handle nested sequences, be sure to read about subclassing set_read_p().

Todo:
  Modify the D4 serialize code so that it supports the true/false behavior of read() for arrays.

Todo:
  Modify all of the stock handlers so they conform to this!

Returns
  False means more data remains to be read, True indicates that no more data need to be read. For Sequence and D4Sequence, this method will generally read one instance of the Sequence; for other types it will generally read the entire variable modulo any limitations due to a constraint. However, the library should be written so that read can return less than all of the data for a variable - serialize() would then call the function until it returns True.

See also
  BaseType

Reimplemented in libdap::Constructor.

Definition at line 905 of file BaseType.cc.

## read_p()

bool libdap::BaseType::read_p | ( |  | ) |

virtual inherited

Has this variable been read?

Returns true if the value(s) for this variable have been read from the data source, otherwise returns false. This method is used to determine when values need to be read using the read() method. When read_p() returns true, this library assumes that buf2val() (and other methods such as get_vec()) can be used to access the value(s) of a variable.

Returns
  True if the variable's value(s) have been read, false otherwise.

Definition at line 477 of file BaseType.cc.

## send_p()

bool libdap::BaseType::send_p | ( |  | ) |

virtual inherited

Should this variable be sent?

Returns the state of the `send_p` property. If true, this variable should be sent to the client, if false, it should not. If no constraint expression (CE) has been evaluated, this property is true for all variables in a data source (i.e., for all the variables listed in a DDS). If a CE has been evaluated, this property is true only for those variables listed in the projection part of the CE.

Returns
  True if the variable should be sent to the client, false otherwise.

Definition at line 551 of file BaseType.cc.

## serialize() [1/2]

bool libdap::Str::serialize | ( | ConstraintEvaluator & | eval,
|  | DDS & | dds,
|  | Marshaller & | m,
|  | bool | ce_eval = `true`
| ) |  |

override virtual

Move data to the net, then remove them from the object.

Sends the data from the indicated (local) dataset through the connection identified by the Marshaller parameter. If the data is not already incorporated into the DDS object, read the data from the dataset. Once the data are sent (written to the Marshaller), they are deleted from the object and the object state is reset so that they will be read again if the read() method is called.

This function is only used on the server side of the client/server connection, and is generally only called from the ResponseBuilder functions. It has no BaseType implementation; each datatype child class supplies its own implementation.

Parameters

  eval | Use this as the constraint expression evaluator.
  dds | The Data Descriptor Structure object corresponding to this dataset. See The DODS User Manual for information about this structure.
  m | A marshaller used to serialize data types
  ce_eval | A boolean value indicating whether to evaluate the DODS constraint expression that may accompany this dataset. The constraint expression is stored in the dds.

Returns
  This method always returns true. Older versions used the return value to signal success or failure.

Note
  We changed the default behavior of this method so that it calls BaseType::clear_local_data() once the values are sent. This, combined with the behavior that read() is called by this method just before data are sent, means that data for any given variable remain in memory for the shortest time possible. Furthermore, since variables are serialized one at a time, no more than one variable's data will be in memory at any given time when using the default behavior. Some code - code that uses intern_data() or server functions - might alter this default behavior. Only Array (i.e. Vector), Sequence, D4Sequence and D4Opaque types actually hold data in dynamically allocated memory, so sonly those types have the new/changed behavior. This change was made on 7/5/15.

Exceptions

  InternalErr. |
  Error. |

See also
  DDS

Reimplemented from libdap::BaseType.

Definition at line 139 of file Str.cc.

## serialize() [2/2]

void libdap::Str::serialize | ( | D4StreamMarshaller & | m,
|  | DMR & | dmr,
|  | bool | filter = `false`
| ) |  |

override virtual

Serialize an Int8.

Parameters

  m |
  dmr | Unused
  eval | Unused
  filter | Unused

Exceptions

  Error | is thrown if the value needs to be read and that operation fails.

Reimplemented from libdap::BaseType.

Definition at line 186 of file Str.cc.

## set_attr_table()

void libdap::BaseType::set_attr_table | ( | const AttrTable & | at | ) |

virtual inherited

Set this variable's attribute table.

Parameters

  at | Source of the attributes.

Definition at line 587 of file BaseType.cc.

## set_attributes()

void libdap::BaseType::set_attributes | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 603 of file BaseType.cc.

## set_attributes_nocopy()

void libdap::BaseType::set_attributes_nocopy | ( | D4Attributes * | attrs | ) |

virtual inherited

Definition at line 609 of file BaseType.cc.

## set_in_selection()

void libdap::BaseType::set_in_selection | ( | bool | state | ) |

virtual inherited

Set the in_selection property to state. This property indicates that the variable is used as a parameter to a constraint expression function or that it appears as an argument in a selection sub-expression. If set (true), implementations of the BaseType::read() method should read this variable.

Parameters

  state | Set the in_selection property to this state.

See also
  BaseType::read()
  BaseType::is_in_selection() for more information.

Reimplemented in libdap::Constructor.

Definition at line 715 of file BaseType.cc.

## set_is_dap4()

virtual void libdap::BaseType::set_is_dap4 | ( | const bool | v | ) |

inline virtual inherited

Definition at line 184 of file BaseType.h.

## set_length()

virtual void libdap::BaseType::set_length | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements for this variable. use -1 to indicate nothing set.

See also
  Vector

Parameters

  l | The number of elements

Deprecated:
  Use set_length_ll() instead

Reimplemented in libdap::D4Sequence, and libdap::Vector.

Definition at line 226 of file BaseType.h.

## set_length_ll()

virtual void libdap::BaseType::set_length_ll | ( | int64_t |  | ) |

inline virtual inherited

Set the number of elements in this variable This version of the function deprecates set_length() which is limited to 32-bit sizes. The field uses -1 as a sentinel value indicating that the Vector/Array holds no values.

Parameters

  l | The number of elements in the variable

Reimplemented in libdap::Vector.

Definition at line 234 of file BaseType.h.

## set_name()

void libdap::BaseType::set_name | ( | const string & | n | ) |

virtual inherited

Sets the name of the class instance.

Reimplemented in libdap::Vector.

Definition at line 341 of file BaseType.cc.

## set_parent()

void libdap::BaseType::set_parent | ( | BaseType * | parent | ) |

virtual inherited

Set the `parent` property for this variable.

Note
  Added ability to set parent to null. 10/19/12 jhrg

Parameters

  parent | Pointer to the Constructor of Vector parent variable or null if the variable has no parent (if it is at the top-level of a DAP2/3 DDS).

Exceptions

  InternalErr | thrown if called with anything other than a Constructor, Vector or Null.

Definition at line 730 of file BaseType.cc.

## set_read_p()

void libdap::BaseType::set_read_p | ( | bool | state | ) |

virtual inherited

Sets the value of the read_p property.

Sets the value of the `read_p` property. This indicates that the value(s) of this variable has/have been read. An implementation of the read() method should use this to set the `read_p` property to true.

Note
  If the is_synthesized property is true, this method will not alter the is_read property. If you need that behavior, specialize the method in your subclasses if the various types.
  For most of the types the default implementation of this method is fine. However, if you're building a server which must handle data represented using nested sequences, then you may need to provide a specialization of Sequence::set_read_p(). By default Sequence::set_read_p() recursively sets the read_p property for all child variables to state. For servers where one Sequence reads an outer set of values and another reads an inner set, this is cumbersome. In such a case, it is easier to specialize Sequence::set_read_p() so that it does not recursively set the read_p property for the inner Sequence. Be sure to see the documentation for the read() method!

Todo:
  Look at making synthesized variables easier to implement and at making them more integrated into the overall CE evaluation process. Maybe the code that computes the synthesized var's value should be in the that variable's read() method? This might provide a way to get rid of the awkward 'projection functions' by replacing them with real children of BaseType. It would also provide a way to clean up the way the synthesized_p prop intrudes on the read_p prop.

See also
  BaseType::read()

Parameters

  state | Set the read_p property to this state.

Reimplemented in libdap::Constructor, libdap::D4Group, and libdap::Vector.

Definition at line 513 of file BaseType.cc.

## set_send_p()

void libdap::BaseType::set_send_p | ( | bool | state | ) |

virtual inherited

Sets the value of the `send_p` flag. This function is meant to be called from within the constraint evaluator of other code which determines that this variable should be returned to the client. Data are ready to be sent when both the `d_is_send` and `d_is_read` flags are set to TRUE.

Parameters

  state | The logical state to set the `send_p` flag.

Reimplemented in libdap::Constructor, libdap::D4Group, and libdap::Vector.

Definition at line 565 of file BaseType.cc.

## set_synthesized_p()

void libdap::BaseType::set_synthesized_p | ( | bool | state | ) |

virtual inherited

Set the synthesized flag. Before setting this flag be sure to set the `read_p()` state. Once this flag is set you cannot alter the state of the `read_p` flag!

See also
  synthesized_p()

Definition at line 460 of file BaseType.cc.

## set_type()

void libdap::BaseType::set_type | ( | const Type & | t | ) |

virtual inherited

Sets the type of the class instance.

Definition at line 369 of file BaseType.cc.

## set_value()

bool libdap::Str::set_value | ( | const string & | value | ) |

virtual

Set the value of this instance.

Parameters

  value | The value

Returns
  Always returns true; the return type of bool is for compatibility with the Passive* subclasses written by HAO.

Definition at line 257 of file Str.cc.

## synthesized_p()

bool libdap::BaseType::synthesized_p | ( |  | ) |

virtual inherited

Returns true if the variable is a synthesized variable. A synthesized variable is one that is added to the dataset by the server (usually with a ‘projection function’.

Definition at line 449 of file BaseType.cc.

## toString()

string libdap::BaseType::toString | ( |  | ) |

virtual inherited

Write out the object's internal fields in a string. To be used for debugging when regular inspection w/ddd or gdb isn't enough.

Returns
  A string which shows the object's internal stuff.

Reimplemented in libdap::Sequence.

Definition at line 180 of file BaseType.cc.

## transfer_attributes()

void libdap::BaseType::transfer_attributes | ( | AttrTable * | at_container | ) |

virtual inherited

Transfer attributes from a DAS object into this variable. Because of the rough history of the DAS object and the way that various server code built the DAS, this is necessarily a heuristic process. The intent is that this method will be overridden by handlers that need to look for certain patterns in the DAS (e.g., hdf4's odd variable_dim_n; where n = 0, 1, 2, ...) attribute containers.

There should be a one-to-one mapping between variables and attribute containers. However, in some cases one variable has attributes spread across several top level containers and in some cases one container is used by several variables

Note
  This method is technically unnecessary because a server (or client) can easily add attributes directly using the DDS::get_attr_table or BaseType::get_attr_table methods and then poke values in using any of the methods AttrTable provides. This method exists to ease the transition to DDS objects which contain attribute information for the existing servers (Since they all make DAS objects separately from the DDS). They could be modified to use the same AttrTable methods but operate on the AttrTable instances in a DDS/BaseType instead of those in a DAS.

Parameters

  at_container | Transfer attributes from this container.

Returns
  void

Reimplemented in libdap::Constructor, and libdap::Grid.

Definition at line 641 of file BaseType.cc.

## transform_to_dap2()

std::vector< BaseType * > * libdap::BaseType::transform_to_dap2 | ( | AttrTable * | parent_attr_table | ) |

virtual inherited

DAP4 to DAP2 transform.

For the current BaseType, return a DAP2 'copy' of the variable.

Note
  For most DAP4 types, in this implementation of DAP2 the corresponding DAP4 type is the same. These types have a different representations in DAP2 and DAP4: Sequences (which are D4Sequences in the DAP4 implementation),
  - Grids (which are semantically subsumed by coverages in DAP4)
  - Arrays (which use shared dimensions in DAP4)

Additionally DAP4 adds the following types:

- UInt8, Int8, and Char which map to Byte in DAP2.
- Int64, Unit64 which have no natural representation in DAP2.
- Opaque Possible Byte stuff[] plus metadata?
- Enum's can be represented as Int32.
- Groups, with the exception of the root group "disappear" into the names of their member variables. Specifically the Group name is add as a prefix followed by a "/" separator to the names of all of the Group's member groups variables.

Parameters

  The | AttrTable pointer parent_attr_table is used by Groups, which disappear from the DAP2 representation. Their children are returned in the the BAseType vector their attributes are added to parent_attr_table;

Returns
  A pointer to a vector of BaseType pointers (right?). In most cases this vector will contain a single pointer but DAP4 types 'disappear' such as Group will return all of their member variables in the vector. DAP4 types with no representation in DAP2 (ex: UInt64) the will return a NULL pointer and so this must be tested!

Reimplemented in libdap::Structure, libdap::Array, libdap::Byte, libdap::D4Enum, libdap::D4Group, libdap::D4Opaque, libdap::Int64, libdap::Int8, and libdap::UInt64.

Definition at line 255 of file BaseType.cc.

## transform_to_dap4()

void libdap::BaseType::transform_to_dap4 | ( | D4Group * | root,
|  | Constructor * | container
| ) |  |

virtual inherited

DAP2 to DAP4 transform.

For the current BaseType, return a DAP4 'copy' of the variable.

Note
  For most DAP2 types, in this implementation of DAP4 the corresponding DAP4 type is the same. The different types are Sequences (which are D4Sequences in the DAP4 implementation), Grids (which are coverages) and Arrays (which use shared dimensions).

Parameters

  root | The root group that should hold this new variable. Add Group-level stuff here (e.g., D4Dimensions).
  container | Add the new variable to this container.

Returns
  A pointer to the transformed variable

Reimplemented in libdap::Grid, libdap::Sequence, libdap::Structure, libdap::Array, and libdap::Constructor.

Definition at line 212 of file BaseType.cc.

## type()

Type libdap::BaseType::type | ( |  | ) | const

virtual inherited

Returns the type of the class instance.

Definition at line 362 of file BaseType.cc.

## type_name()

string libdap::BaseType::type_name | ( |  | ) | const

virtual inherited

Returns the type of the class instance as a string.

Definition at line 376 of file BaseType.cc.

## val2buf()

unsigned int libdap::Str::val2buf | ( | void * | val,
|  | bool | reuse = `false`
| ) |  |

override virtual

Store the value referenced by val in this object. Even though the type of val is `void*`, this method assumes the type is `string*`. Note that the value is copied so the caller if free to throw away/reuse the actual parameter once this call has returned.

Parameters

  val | A pointer to a C++ string object.
  reuse | Not used by this version of the method.

Exceptions

  IntenalErr | if val is null.

Returns
  The width of the pointer.

Implements libdap::BaseType.

Definition at line 238 of file Str.cc.

## value()

string libdap::Str::value | ( |  | ) | const

virtual

Get the value of this instance.

Returns
  The value.

Definition at line 268 of file Str.cc.

## var() [1/2]

BaseType * libdap::BaseType::var | ( | const string & | name,
|  | btp_stack & | s
| ) |  |

virtual inherited

This version of var(...) searches for name and returns a pointer to the BaseType object if found. It uses the same search algorithm as BaseType::var(const string &, bool, btp_stack *) when exact_match is false. In addition to returning a pointer to the variable, it pushes onto s a BaseType pointer to each constructor type that ultimately contains name.

Note
  The BaseType implementation always returns null. There are no default values for the parameters. If var() is called w/o any params, the three parameter version will be used.

Deprecated:
  This method is deprecated because it tries first to use exact_match and, if that fails, then tries leaf_match. It's better to use the alternate form of var(...) and specify exactly what you'd like to do.

Returns
  A pointer to the named variable.

Reimplemented in libdap::Constructor, and libdap::Vector.

Definition at line 786 of file BaseType.cc.

## var() [2/2]

BaseType * libdap::BaseType::var | ( | const string & | name = `""`,
|  | bool | exact_match = `true`,
|  | btp_stack * | s = `nullptr`
| ) |  |

virtual inherited

Returns a pointer to a member of a constructor class.

Returns a pointer to the contained variable in a composite class. The composite classes are those made up of aggregated simple data types. Array, Grid, and Structure are composite types, while Int and Float are simple types. This function is only used by composite classes. The BaseType implementation always returns null.

Several of the subclasses provide alternate access methods that make sense for that particular data type. For example, the Array class defines a `*var(int i)` method that returns the ith entry in the Array data, and the Structure provides a `*var(Vars_iter)` function using a pseudo-index to access the different members of the structure.

Parameters

  name | The name of the class member. Defaults to ""

  exact_match

  True if only interested in variables whose full names match n exactly. If false, returns the first variable whose name matches name. For example, if name is `x` and `point.x` is a variable, then var("x", false) would return a BaseType pointer to `point.x`. If exact_match was `true` then name would need to be `"point.x"` for var to return that pointer. This feature simplifies constraint expressions for datasets which have complex, nested, constructor variables. Defaults to true.

  s | Record the path to name. Defaults to null, in which case it is not used.

Returns
  A pointer to the member named in the n argument. If no name is given, the function returns the first (only) variable. For example, an Array has only one variable, while a Structure can have many.

Reimplemented in libdap::Constructor, and libdap::Vector.

Definition at line 764 of file BaseType.cc.

## width()

unsigned int libdap::Str::width | ( | bool | constrained = `false` | ) | const

inline override virtual

How many bytes does this variable use Return the number of bytes of storage this variable uses. For scalar types, this is pretty simple (an int32 uses 4 bytes, etc.). For arrays and Constructors, it is a bit more complex. Note that a scalar String variable uses sizeof(String*) bytes, not the length of the string value. The width() of a String array returns the number of elements in the array times sizeof(String*).

Parameters

  constrained | Should the current constraint be taken into account?

Returns
  Bytes of storage

Reimplemented from libdap::BaseType.

Definition at line 79 of file Str.h.

## width_ll()

int64_t libdap::Str::width_ll | ( | bool | = `false` | ) | const

inline override virtual

Reimplemented from libdap::BaseType.

Definition at line 84 of file Str.h.

## Member Data Documentation

## d_buf

string libdap::Str::d_buf

protected

Definition at line 64 of file Str.h.

The documentation for this class was generated from the following files:

- Str.h
- Str.cc